#!/bin/bash

#Written by floyd fuh (floyd_fuh@yahoo.de)
#Importing the Burp root CA into your rooted Android phone
#You need a rooted and s-off Phone!

#Read this: http://wiki.cacert.org/ImportRootCert#Android_Phones
#and if you have time: http://android.git.kernel.org/?p=platform/libcore.git;a=tree;f=luni/src/main/files;hb=HEAD
#and: http://un-excogitate.org/archives/2009/02/28/self-signed-certificates-in-burp/

######################################
#CHANGE BEFORE STARTING

#A: SET JAVA EXT
JAVA_EXT_DIRECTORY="/System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home/lib/ext/"
#set java ext directory variable above (normaly under $JAVA_HOME/lib/ext/)
echo "[INFO] Please specify your JAVA_EXT_DIRECTORY in the script.\n"

#B: BACKUP cacerts.bks
#backup cacerts.bks and then remove next line
echo "[INFO] Please backup your /system/etc/security/cacerts.bks from the phone.\n"

#C: GET a cacerts.bks to modify
echo "[INFO] Choose one of the following methods:"
echo "[INFO] 1. Pull cacerts.bks from the phone. In general the better idea, but my file from the phone was corrupted (getting errormessages in keytool)."
echo "[INFO] 2. Download cacerts.bks from Android source code."
echo "[INFO] 3. Use the cacerts.bks already in this folder I already downloaded (you don't need to change anything)\n"
#method 1
#adb pull /system/etc/security/cacerts.bks cacerts.bks
#method 2
#wget -O cacerts.bks "http://android.git.kernel.org/?p=platform/libcore.git;a=blob;f=luni/src/main/files/cacerts.bks;h=0022b411742f9671af1d297ac79df22f62f3f90d;hb=HEAD"
#method 3 does not need any changes

#D: GET your specific PortSwiggerCA.crt
echo "[INFO] Please put your Burp CA certificate as PortSwiggerCA.crt in this folder"
echo "[INFO] Instructions on how to get your PortSwiggerCA.crt from Internet Explorer or Firefox:"
echo "[INFO]  http://portswigger.net/burp/help/servercerts.html"

#Remove next line when configuration is finished
exit

#END
#####################################

if [ -e ./bcprov-jdk16-141.jar ]
then
	echo "[INFO] Found bouncycastle crypto provider, copying to $JAVA_HOME/jre/lib/ext/"
else
	echo "[INFO] Didn't found bouncycastle crypto provider, downloading it from:"
	wget "[INFO] http://bouncycastle.org/download/bcprov-jdk16-141.jar"
fi
echo "[INFO] Copying with sudo to $JAVA_EXT_DIRECTORY"
sudo cp ./bcprov-jdk16-141.jar $JAVA_EXT_DIRECTORY

if [ -e ./PortSwiggerCA.crt ]
then
	echo "[INFO] Found PortSwiggerCA.crt"
else
	echo "[INFO] Please put your Burp CA certificate as PortSwiggerCA.crt in this folder"
	echo "[INFO] Instructions on how to get your PortSwiggerCA.crt from Internet Explorer or Firefox:"
	echo "[INFO]  http://portswigger.net/burp/help/servercerts.html"
	echo "[INFO] Aborting"
	exit
fi


if [ -e ./cacerts.bks ]
then
	echo "[INFO] Found cacerts.bks, preceeding"
	cp cacerts.bks cacerts-new-with-burp.bks
else
	echo "[INFO] Didn't find cacerts.bks, aborting."
	exit
fi

echo "[INFO] Now generating new cacerts-new-with-burp.bks"

keytool -keystore cacerts-new-with-burp.bks -storetype BKS -provider org.bouncycastle.jce.provider.BouncyCastleProvider -storepass changeit -importcert -trustcacerts -alias portswigger -file PortSwiggerCA.crt

echo "\n[INFO] Checking if burp CA was correctly installed (only if next line not empty)..."
if keytool -keystore cacerts-new-with-burp.bks -storetype BKS -provider org.bouncycastle.jce.provider.BouncyCastleProvider -storepass changeit -v -list | grep -i portswigger ; then
    echo "[INFO] Seems like the cert was correctly included!"
else
    echo "[INFO] The cert was not correctly installed, there is no portswigger cert in cacerts-new-with-burp.bks. Aborting"
    exit
fi

echo "[INFO] Pushing cacerts-new-with-burp.bks to phone"
adb push ./cacerts-new-with-burp.bks /sdcard/cacerts-new-with-burp.bks

echo "[INFO] Execute the next two lines in your adb shell that will open shortly"
echo "[INFO] Unmount SD card if mounted!"

echo "su"
echo "cd /; mount -o remount,rw -o rootfs rootfs /; mount -o remount,rw -o yaffs2 /dev/block/mtdblock3 /system; cp /sdcard/cacerts-new-with-burp.bks /system/etc/security/cacerts.bks"

adb shell
